Index: org/jivesoftware/xiff/core/XMPPBOSHConnection.as
===================================================================
--- org/jivesoftware/xiff/core/XMPPBOSHConnection.as	(revision 10925)
+++ org/jivesoftware/xiff/core/XMPPBOSHConnection.as	(working copy)
@@ -331,7 +331,7 @@
 				bindConnection();
 			}
 			
-			if(bodyNode.attributes["type"] == "terminate")
+			if(bodyNode.attributes["type"] == "terminate" || bodyNode.attributes["type"] == "terminal")
 			{
 				dispatchError("BOSH Error", bodyNode.attributes["condition"], "", -1);
 				active = false;
Index: org/jivesoftware/xiff/core/XMPPConnection.as
===================================================================
--- org/jivesoftware/xiff/core/XMPPConnection.as	(revision 10925)
+++ org/jivesoftware/xiff/core/XMPPConnection.as	(working copy)
@@ -409,7 +409,7 @@
 			var ext:RegisterExtension = new RegisterExtension(regIQ.getNode());
 	
 			for( var i:String in fieldMap ) {
-				ext[i] = fieldMap[i];
+				ext.setField(i, fieldMap[i]);
 			}
 			if (key != null) {
 				ext.key = key;
@@ -477,6 +477,7 @@
 				var event:RegistrationFieldsEvent = new RegistrationFieldsEvent();
 				event.fields = fields;
 				event.data = ext;
+				dispatchEvent(event);
 			}
 			catch (e:Error)
 			 {
Index: org/jivesoftware/xiff/data/register/RegisterExtension.as
===================================================================
--- org/jivesoftware/xiff/data/register/RegisterExtension.as	(revision 10925)
+++ org/jivesoftware/xiff/data/register/RegisterExtension.as	(working copy)
@@ -140,8 +140,11 @@
 	
 	
 		public function get key():String 
-		{ 
-			return myKeyNode.firstChild.nodeValue; 
+		{
+			if (myKeyNode) {
+				return myKeyNode.firstChild.nodeValue;
+			}
+			return null;
 		}
 	
 		public function set key(val:String):void
@@ -214,4 +217,4 @@
 		public function get text():String { return getField("text"); }
 		public function set text(val:String):void { setField("text", val); }
 	}
-}
\ No newline at end of file
+}
